#ifndef LIST_H
#define LIST_H

#include <iostream>

template <typename T>
class list{

private:

  struct listNode{   // definition of a single node

    T item_;
    listNode * next_;

    listNode(): next_(0) {};
    listNode(T i, listNode * nx = 0): item_(i), next_(nx) {};
  };

  listNode * head_;   // head of the list
  T defaultValue_;    // default value

  // merge
  listNode * merge(listNode * a, listNode * b){
    
    listNode dummy; 
    listNode * head = &dummy, * c = head;
    while ( (a != 0) && (b != 0) ) // scan the two list
      if (a->item_ < b->item_)     // a is the min
	{ c->next_ = a; c = a; a = a->next_;}// move a to nxt
      else
	{ c->next_ = b; c = b; b = b->next_;}// move b to nxt
    c->next_ = (a==0) ? b : a; // a is ended, then link b

    //
    std::cerr << "\t Merged on ";
    listNode * tmp = head->next_;
    while (tmp){
      std::cerr << " " << tmp->item_;
      tmp = tmp->next_;
    }
    std::cerr << std::endl;

    //

    return head->next_;
  };

  // mergesort
  listNode* mergesort(listNode* c){
    
    if (c==0 || c->next_ == 0) return c;
    
    //
    std::cerr << "Calling mergesort on ";
    listNode * tmp = c;
    while (tmp){
      std::cerr << " " << tmp->item_;
      tmp = tmp->next_;
    }
    std::cerr << std::endl;
    //

    // a points to the first, b to the next one
    link a = c, b = c->next_;
    
    // there are at least 3
    while ((b != 0) && (b->next_ != 0))
      { c = c->next_; b = b->next_->next_; }
    // exiting the above while c will point
    // to the half point of list
    
    b = c->next_; // this is the next pos in list
    c->next_ = 0; // terminate the list after half point

    return merge(mergesort(a), mergesort(b));
  };


public:
  
  typedef listNode * link;

  // constructors
  list() : head_(new listNode){}; 
  list (T defaultValue) : 
    head_(new listNode), defaultValue_(defaultValue){};

  // destructors
  ~list(){   
    
    link tmp = head_->next_; // take first one
    
    while (tmp){                   // is there something
      
      head_->next_ = tmp->next_;   // get the next one
      delete tmp;                  // delete current
      tmp = head_->next_;          // go to the next one
    }
  }

  // methods
  
  //    empty
  bool empty() const;

  //    insert
  void insertNode(const T &element);
  
  //    delete
  bool deleteNode(const T &element);

  //    sort
  void sort();

  // friends

  friend std::ostream& operator <<(std::ostream& os, list &l)
  {
    link tmp;
    unsigned int i =1;
    for (tmp = l.head_->next_; tmp!=0; tmp=tmp->next_)
      os << i++ << " element = " << tmp->item_ << std::endl;
    return os;
  }; 
};

// template definition
#include "list.cpp"
#endif
